--------------------------------------------------------------------------
-- LAB 03: example - generic counter 
-- Test bench
--------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity top_tb is
end entity;

architecture Behavioral of top_tb is
    component top is
    port ( CLK100MHZ: in  std_logic;
           BTNC:      in  std_logic;
           SW_0:      in  std_logic;
           SW_1:      in  std_logic;
           LED:       out signed (3 downto 0));
    end component;
    
    constant clock_period: time := 10 ns;
    signal clock:         std_logic := '0';
    signal reset:         std_logic := '0';
    signal count_up:      std_logic := '0';
    signal count_down:    std_logic := '0';
    signal counter_value: signed (3 downto 0);
    
begin

    uut: top 
    port map(
        CLK100MHZ => clock,
        BTNC      => reset,
        SW_0      => count_up,
        SW_1      => count_down,
        LED       => counter_value
    );

    clk: process
    begin
        wait for clock_period/2;
        clock <= not clock;
    end process;

    stimuli: process
    begin        
        reset <= '1';
        wait for 2*clock_period;
        reset <= '0';
        wait for 2*clock_period;
        count_up <= '1';
        wait for 15*clock_period;
        count_up <= '0';
        count_down <= '1';
        wait;
    end process;
    
end Behavioral;
